stages:
  - build
  - manifest

services:
  - docker:dind
  
variables:
  IMAGE_NAME: $CI_REGISTRY_IMAGE

.build:
  image: docker:stable
  stage: build
  before_script:
    - docker info
    - wget https://github.com/multiarch/qemu-user-static/releases/download/v2.12.0/qemu-arm-static -O qemu-arm-static
    - chmod 554 qemu-arm-static    
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

build:amd64:release:
  extends: .build
  only:
    refs:
      - master
  script:
    - docker build -t $IMAGE_NAME/amd64:latest --build-arg BASE_IMAGE=docker:stable .
    - docker push $IMAGE_NAME/amd64:latest

build:armv7:release:
  extends: .build
  only:
    refs:
      - master
  script:
    - docker build -t $IMAGE_NAME/armv7:latest --build-arg BASE_IMAGE=arm32v7/docker:stable .
    - docker push $IMAGE_NAME/armv7:latest

manifest:release:
  image: docker:stable
  stage: manifest
  only:
    refs:
      - master
  before_script:
    - export DOCKER_CLI_EXPERIMENTAL=enabled
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker manifest create $IMAGE_NAME:latest $IMAGE_NAME/amd64:latest $IMAGE_NAME/armv7:latest
    - docker manifest annotate --os linux --arch amd64 $IMAGE_NAME:latest $IMAGE_NAME/amd64:latest
    - docker manifest annotate --os linux --arch arm --variant v7 $IMAGE_NAME:latest $IMAGE_NAME/armv7:latest
    - docker manifest push $IMAGE_NAME:latest

